/**
 *
 *  Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 */
package com.example.ExpectedException;

import java.io.Serializable;

import java.math.BigDecimal;
import java.math.BigInteger;

import java.util.List;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#getStringVal <em>String Val</em>}</li>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#isBooleanVal <em>Boolean Val</em>}</li>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#getByteVal <em>Byte Val</em>}</li>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#getDecimalVal <em>Decimal Val</em>}</li>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#getIntVal <em>Int Val</em>}</li>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#getFloatVal <em>Float Val</em>}</li>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#getDoubleVal <em>Double Val</em>}</li>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#getDateVal <em>Date Val</em>}</li>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#getShortVal <em>Short Val</em>}</li>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#getLongVal <em>Long Val</em>}</li>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#getListVal <em>List Val</em>}</li>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#getBytesVal <em>Bytes Val</em>}</li>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#getIntegerVal <em>Integer Val</em>}</li>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#getCharVal <em>Char Val</em>}</li>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#getReadOnlyVal <em>Read Only Val</em>}</li>
 *   <li>{@link com.example.ExpectedException.ExpectedExceptionType#getReadOnlyListVal <em>Read Only List Val</em>}</li>
 * </ul>
 * </p>
 *
 * @extends Serializable
 * @generated
 */
public interface ExpectedExceptionType extends Serializable
{
  /**
   * Returns the value of the '<em><b>String Val</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>String Val</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>String Val</em>' attribute.
   * @see #isSetStringVal()
   * @see #unsetStringVal()
   * @see #setStringVal(String)
   * @generated
   */
  String getStringVal();

  /**
   * Sets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getStringVal <em>String Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>String Val</em>' attribute.
   * @see #isSetStringVal()
   * @see #unsetStringVal()
   * @see #getStringVal()
   * @generated
   */
  void setStringVal(String value);

  /**
   * Unsets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getStringVal <em>String Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetStringVal()
   * @see #getStringVal()
   * @see #setStringVal(String)
   * @generated
   */
  void unsetStringVal();

  /**
   * Returns whether the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getStringVal <em>String Val</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>String Val</em>' attribute is set.
   * @see #unsetStringVal()
   * @see #getStringVal()
   * @see #setStringVal(String)
   * @generated
   */
  boolean isSetStringVal();

  /**
   * Returns the value of the '<em><b>Boolean Val</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Boolean Val</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Boolean Val</em>' attribute.
   * @see #isSetBooleanVal()
   * @see #unsetBooleanVal()
   * @see #setBooleanVal(boolean)
   * @generated
   */
  boolean isBooleanVal();

  /**
   * Sets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#isBooleanVal <em>Boolean Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Boolean Val</em>' attribute.
   * @see #isSetBooleanVal()
   * @see #unsetBooleanVal()
   * @see #isBooleanVal()
   * @generated
   */
  void setBooleanVal(boolean value);

  /**
   * Unsets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#isBooleanVal <em>Boolean Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetBooleanVal()
   * @see #isBooleanVal()
   * @see #setBooleanVal(boolean)
   * @generated
   */
  void unsetBooleanVal();

  /**
   * Returns whether the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#isBooleanVal <em>Boolean Val</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Boolean Val</em>' attribute is set.
   * @see #unsetBooleanVal()
   * @see #isBooleanVal()
   * @see #setBooleanVal(boolean)
   * @generated
   */
  boolean isSetBooleanVal();

  /**
   * Returns the value of the '<em><b>Byte Val</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Byte Val</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Byte Val</em>' attribute.
   * @see #isSetByteVal()
   * @see #unsetByteVal()
   * @see #setByteVal(byte)
   * @generated
   */
  byte getByteVal();

  /**
   * Sets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getByteVal <em>Byte Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Byte Val</em>' attribute.
   * @see #isSetByteVal()
   * @see #unsetByteVal()
   * @see #getByteVal()
   * @generated
   */
  void setByteVal(byte value);

  /**
   * Unsets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getByteVal <em>Byte Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetByteVal()
   * @see #getByteVal()
   * @see #setByteVal(byte)
   * @generated
   */
  void unsetByteVal();

  /**
   * Returns whether the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getByteVal <em>Byte Val</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Byte Val</em>' attribute is set.
   * @see #unsetByteVal()
   * @see #getByteVal()
   * @see #setByteVal(byte)
   * @generated
   */
  boolean isSetByteVal();

  /**
   * Returns the value of the '<em><b>Decimal Val</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Decimal Val</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Decimal Val</em>' attribute.
   * @see #isSetDecimalVal()
   * @see #unsetDecimalVal()
   * @see #setDecimalVal(BigDecimal)
   * @generated
   */
  BigDecimal getDecimalVal();

  /**
   * Sets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getDecimalVal <em>Decimal Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Decimal Val</em>' attribute.
   * @see #isSetDecimalVal()
   * @see #unsetDecimalVal()
   * @see #getDecimalVal()
   * @generated
   */
  void setDecimalVal(BigDecimal value);

  /**
   * Unsets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getDecimalVal <em>Decimal Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetDecimalVal()
   * @see #getDecimalVal()
   * @see #setDecimalVal(BigDecimal)
   * @generated
   */
  void unsetDecimalVal();

  /**
   * Returns whether the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getDecimalVal <em>Decimal Val</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Decimal Val</em>' attribute is set.
   * @see #unsetDecimalVal()
   * @see #getDecimalVal()
   * @see #setDecimalVal(BigDecimal)
   * @generated
   */
  boolean isSetDecimalVal();

  /**
   * Returns the value of the '<em><b>Int Val</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Int Val</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Int Val</em>' attribute.
   * @see #isSetIntVal()
   * @see #unsetIntVal()
   * @see #setIntVal(int)
   * @generated
   */
  int getIntVal();

  /**
   * Sets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getIntVal <em>Int Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Int Val</em>' attribute.
   * @see #isSetIntVal()
   * @see #unsetIntVal()
   * @see #getIntVal()
   * @generated
   */
  void setIntVal(int value);

  /**
   * Unsets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getIntVal <em>Int Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetIntVal()
   * @see #getIntVal()
   * @see #setIntVal(int)
   * @generated
   */
  void unsetIntVal();

  /**
   * Returns whether the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getIntVal <em>Int Val</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Int Val</em>' attribute is set.
   * @see #unsetIntVal()
   * @see #getIntVal()
   * @see #setIntVal(int)
   * @generated
   */
  boolean isSetIntVal();

  /**
   * Returns the value of the '<em><b>Float Val</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Float Val</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Float Val</em>' attribute.
   * @see #isSetFloatVal()
   * @see #unsetFloatVal()
   * @see #setFloatVal(float)
   * @generated
   */
  float getFloatVal();

  /**
   * Sets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getFloatVal <em>Float Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Float Val</em>' attribute.
   * @see #isSetFloatVal()
   * @see #unsetFloatVal()
   * @see #getFloatVal()
   * @generated
   */
  void setFloatVal(float value);

  /**
   * Unsets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getFloatVal <em>Float Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetFloatVal()
   * @see #getFloatVal()
   * @see #setFloatVal(float)
   * @generated
   */
  void unsetFloatVal();

  /**
   * Returns whether the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getFloatVal <em>Float Val</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Float Val</em>' attribute is set.
   * @see #unsetFloatVal()
   * @see #getFloatVal()
   * @see #setFloatVal(float)
   * @generated
   */
  boolean isSetFloatVal();

  /**
   * Returns the value of the '<em><b>Double Val</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Double Val</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Double Val</em>' attribute.
   * @see #isSetDoubleVal()
   * @see #unsetDoubleVal()
   * @see #setDoubleVal(double)
   * @generated
   */
  double getDoubleVal();

  /**
   * Sets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getDoubleVal <em>Double Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Double Val</em>' attribute.
   * @see #isSetDoubleVal()
   * @see #unsetDoubleVal()
   * @see #getDoubleVal()
   * @generated
   */
  void setDoubleVal(double value);

  /**
   * Unsets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getDoubleVal <em>Double Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetDoubleVal()
   * @see #getDoubleVal()
   * @see #setDoubleVal(double)
   * @generated
   */
  void unsetDoubleVal();

  /**
   * Returns whether the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getDoubleVal <em>Double Val</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Double Val</em>' attribute is set.
   * @see #unsetDoubleVal()
   * @see #getDoubleVal()
   * @see #setDoubleVal(double)
   * @generated
   */
  boolean isSetDoubleVal();

  /**
   * Returns the value of the '<em><b>Date Val</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Date Val</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Date Val</em>' attribute.
   * @see #isSetDateVal()
   * @see #unsetDateVal()
   * @see #setDateVal(String)
   * @generated
   */
  String getDateVal();

  /**
   * Sets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getDateVal <em>Date Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Date Val</em>' attribute.
   * @see #isSetDateVal()
   * @see #unsetDateVal()
   * @see #getDateVal()
   * @generated
   */
  void setDateVal(String value);

  /**
   * Unsets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getDateVal <em>Date Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetDateVal()
   * @see #getDateVal()
   * @see #setDateVal(String)
   * @generated
   */
  void unsetDateVal();

  /**
   * Returns whether the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getDateVal <em>Date Val</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Date Val</em>' attribute is set.
   * @see #unsetDateVal()
   * @see #getDateVal()
   * @see #setDateVal(String)
   * @generated
   */
  boolean isSetDateVal();

  /**
   * Returns the value of the '<em><b>Short Val</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Short Val</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Short Val</em>' attribute.
   * @see #isSetShortVal()
   * @see #unsetShortVal()
   * @see #setShortVal(short)
   * @generated
   */
  short getShortVal();

  /**
   * Sets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getShortVal <em>Short Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Short Val</em>' attribute.
   * @see #isSetShortVal()
   * @see #unsetShortVal()
   * @see #getShortVal()
   * @generated
   */
  void setShortVal(short value);

  /**
   * Unsets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getShortVal <em>Short Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetShortVal()
   * @see #getShortVal()
   * @see #setShortVal(short)
   * @generated
   */
  void unsetShortVal();

  /**
   * Returns whether the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getShortVal <em>Short Val</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Short Val</em>' attribute is set.
   * @see #unsetShortVal()
   * @see #getShortVal()
   * @see #setShortVal(short)
   * @generated
   */
  boolean isSetShortVal();

  /**
   * Returns the value of the '<em><b>Long Val</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Long Val</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Long Val</em>' attribute.
   * @see #isSetLongVal()
   * @see #unsetLongVal()
   * @see #setLongVal(long)
   * @generated
   */
  long getLongVal();

  /**
   * Sets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getLongVal <em>Long Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Long Val</em>' attribute.
   * @see #isSetLongVal()
   * @see #unsetLongVal()
   * @see #getLongVal()
   * @generated
   */
  void setLongVal(long value);

  /**
   * Unsets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getLongVal <em>Long Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetLongVal()
   * @see #getLongVal()
   * @see #setLongVal(long)
   * @generated
   */
  void unsetLongVal();

  /**
   * Returns whether the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getLongVal <em>Long Val</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Long Val</em>' attribute is set.
   * @see #unsetLongVal()
   * @see #getLongVal()
   * @see #setLongVal(long)
   * @generated
   */
  boolean isSetLongVal();

  /**
   * Returns the value of the '<em><b>List Val</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>List Val</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>List Val</em>' attribute list.
   * @generated
   */
  List getListVal();

  /**
   * Returns the value of the '<em><b>Bytes Val</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Bytes Val</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Bytes Val</em>' attribute.
   * @see #isSetBytesVal()
   * @see #unsetBytesVal()
   * @see #setBytesVal(byte[])
   * @generated
   */
  byte[] getBytesVal();

  /**
   * Sets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getBytesVal <em>Bytes Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Bytes Val</em>' attribute.
   * @see #isSetBytesVal()
   * @see #unsetBytesVal()
   * @see #getBytesVal()
   * @generated
   */
  void setBytesVal(byte[] value);

  /**
   * Unsets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getBytesVal <em>Bytes Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetBytesVal()
   * @see #getBytesVal()
   * @see #setBytesVal(byte[])
   * @generated
   */
  void unsetBytesVal();

  /**
   * Returns whether the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getBytesVal <em>Bytes Val</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Bytes Val</em>' attribute is set.
   * @see #unsetBytesVal()
   * @see #getBytesVal()
   * @see #setBytesVal(byte[])
   * @generated
   */
  boolean isSetBytesVal();

  /**
   * Returns the value of the '<em><b>Integer Val</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Integer Val</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Integer Val</em>' attribute.
   * @see #isSetIntegerVal()
   * @see #unsetIntegerVal()
   * @see #setIntegerVal(BigInteger)
   * @generated
   */
  BigInteger getIntegerVal();

  /**
   * Sets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getIntegerVal <em>Integer Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Integer Val</em>' attribute.
   * @see #isSetIntegerVal()
   * @see #unsetIntegerVal()
   * @see #getIntegerVal()
   * @generated
   */
  void setIntegerVal(BigInteger value);

  /**
   * Unsets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getIntegerVal <em>Integer Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetIntegerVal()
   * @see #getIntegerVal()
   * @see #setIntegerVal(BigInteger)
   * @generated
   */
  void unsetIntegerVal();

  /**
   * Returns whether the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getIntegerVal <em>Integer Val</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Integer Val</em>' attribute is set.
   * @see #unsetIntegerVal()
   * @see #getIntegerVal()
   * @see #setIntegerVal(BigInteger)
   * @generated
   */
  boolean isSetIntegerVal();

  /**
   * Returns the value of the '<em><b>Char Val</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Char Val</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Char Val</em>' attribute.
   * @see #isSetCharVal()
   * @see #unsetCharVal()
   * @see #setCharVal(String)
   * @generated
   */
  String getCharVal();

  /**
   * Sets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getCharVal <em>Char Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Char Val</em>' attribute.
   * @see #isSetCharVal()
   * @see #unsetCharVal()
   * @see #getCharVal()
   * @generated
   */
  void setCharVal(String value);

  /**
   * Unsets the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getCharVal <em>Char Val</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetCharVal()
   * @see #getCharVal()
   * @see #setCharVal(String)
   * @generated
   */
  void unsetCharVal();

  /**
   * Returns whether the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getCharVal <em>Char Val</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Char Val</em>' attribute is set.
   * @see #unsetCharVal()
   * @see #getCharVal()
   * @see #setCharVal(String)
   * @generated
   */
  boolean isSetCharVal();

  /**
   * Returns the value of the '<em><b>Read Only Val</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Read Only Val</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Read Only Val</em>' attribute.
   * @see #isSetReadOnlyVal()
   * @generated
   */
  String getReadOnlyVal();

  /**
   * Returns whether the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getReadOnlyVal <em>Read Only Val</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Read Only Val</em>' attribute is set.
   * @see #getReadOnlyVal()
   * @generated
   */
  boolean isSetReadOnlyVal();

  /**
   * Returns the value of the '<em><b>Read Only List Val</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Read Only List Val</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Read Only List Val</em>' attribute.
   * @see #isSetReadOnlyListVal()
   * @generated
   */
  String getReadOnlyListVal();

  /**
   * Returns whether the value of the '{@link com.example.ExpectedException.ExpectedExceptionType#getReadOnlyListVal <em>Read Only List Val</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Read Only List Val</em>' attribute is set.
   * @see #getReadOnlyListVal()
   * @generated
   */
  boolean isSetReadOnlyListVal();

} // ExpectedExceptionType
